# 用 pyinstaller 编译的执行文件
# 导入用到的模块
#import robotparser

import scrapy

# 项目里用到的模块
import sys
import os
import re
from pathlib import Path
import shonenmagazine.settings
import shonenmagazine.items
import shonenmagazine.middlewares
import shonenmagazine.pipelines
from shonenmagazine.items import ShonenmagazineItem
import json
from io import BytesIO
import urllib3
import PIL
import requests
import chardet
import certifi

from shonenmagazine.spiders.detail import DetailSpider
from scrapy.crawler import CrawlerProcess
from scrapy.utils.project import get_project_settings
# 程序开始
try:
    # 输入爬取的章节地址，多个用（,）逗号分割
    print('欢迎使用此脚本，此脚本只支持：https://pocket.shonenmagazine.com/下公开的漫画，此工具仅用于学习使用，禁止出售与与盗用漫画作者的劳动成果。作者Q：1713172499')
    input_start_urls = str(input('请输入要爬取的漫画章节地址，如：https://pocket.shonenmagazine.com/episode/10834108156634319373，多个请用（,）英文逗号分割，输入后回车。\n'))

    if input_start_urls == '':
        raise Exception('爬取地址不能为空')

    start_urls = input_start_urls.split(',')
    print("您输入的爬取地址：")
    print(start_urls)

    # 是否自动爬取下一章节
    print("是否自动爬取下一章节？请输入：0,是 | 1 否。")
    crawl_mode = int(input("请输入 0/1：\n"))
    if crawl_mode == 0:
        crawl_mode = True
        print('————爬取模式：自动爬取下一章')
    else:
        crawl_mode = False
        print('————爬取模式：只爬当前章节')
    # 获取项目配置
    settings = get_project_settings()
    # 创建爬虫进程
    process = CrawlerProcess(settings)
    # 执行命令，
    process.crawl(DetailSpider, start_urls=input_start_urls,crawl_mode=crawl_mode)
    process.start()  # 脚本将在这里阻塞，直到爬行完成

    print("爬取完成！！请查看脚本目录下的comics目录~点击右上角可关闭此脚本")
    # 防止cmd直接退出
    while 1:
        pass
except:
    print("运行发生错误，错误信息：")
    print(sys.exc_info())
    print("按两次Ctrl+C退出")
    # 防止cmd直接退出
    while 1:
        pass
    raise